#!/usr/bin/python   
# encoding: utf-8

# A. Gerber, 2009 - 2011
# This program ist free software. 

import os, datetime, commands
import sys
import time
import glob

#--------------------   Configuration ----------------------
DO_TSA = True
numberdirs = 100000
backupdir = "/media/disk/praxis"    
newArchiveDir = '/media/disk/praxis/neu'  # dir name for archive containing changed files
sourcedir = "/home/praxisdaten/"
chainfile = 'home/praxisdaten/etc/chain.txt'

chainfile = "/misc/praxisdaten/etc/chain.txt"
excludes=('*.mp3','*.avi','*.AVI', '*~', '*.log', '*.sem', '*.prn', '*.ps', 
'a/sagem.doc', '.Trash-1000/*', 'VirtualBox/*') 
#'a/med/glt.fpt',
#'a/med/glp.cdx',
#'a/med/rab.cdx',
#'a/med/glr.dbf',
#'a/med/rab.dbf',
#'a/med/glp.dbf',
#'a/med/gla.dbf',
#'a/med/gfi.fpt')
# -----------------------------------------------------------   
try:
    if not os.path.exists(backupdir):
        os.makedirs(backupdir)

    now = datetime.datetime.now()
    now = time.strftime("%Y-%m-%d_%H-%M-%S")
    excludes = ["--exclude='%s'" % (x,) for x in excludes]   

    mydirs = glob.glob(os.path.join(backupdir, '*-*'))
    mydirs.sort()

    call = ['/usr/bin/rsync']
    call.append('-av')   

    # if we don't have a previous folder we shouldn't use link-location   
    if len(mydirs) > 0:
        call.append('--link-dest='+os.path.join(backupdir,mydirs[-1]))   

    for e in excludes:
        call.append(e)   

    destdir = os.path.join(backupdir, now)
    call.append(sourcedir)
    call.append(destdir)
    call = ' '.join(call)
    os.mkdir(destdir)   # create dir
    os.system(call)     # do the backup
    os.system('touch ' + destdir)  # set mtime to current time

    # TSA (time stamping authority) stuff
    if DO_TSA and len(mydirs) >0:
        print '-' * 80
        if not os.path.exists(newArchiveDir):
            os.makedirs(newArchiveDir)

        newfilesPathName = os.path.join(newArchiveDir, '%s_datenneu.tgz' % now)
        last_destdir = os.path.join(backupdir, mydirs[-1]) 
        cmd = 'find %s -newer %s -type f -print0 | xargs -0 tar -czv --no-recursion -f %s' % \
              (destdir, last_destdir, newfilesPathName)
        print 'Geänderte Dateien archivieren:', newfilesPathName
        rc, lines = commands.getstatusoutput(cmd)
        if rc == 0:
            cmd = 'openssl_ts ts -query -data %s -cert -out /tmp/request.tsq' % newfilesPathName
            rc, lines = commands.getstatusoutput(cmd)
            if rc == 0:
                tsrfile = os.path.join(newArchiveDir, '%s_response.tsr' % now)
                print 'Zeitstempel an Server senden.'
                cmd = 'wget --post-file=/tmp/request.tsq -O %s zeitstempel.dfn.de' % tsrfile
                rc, lines = commands.getstatusoutput(cmd)
                if rc == 0:
                    print 'Zeitstempel verifizieren:'
                    cmd = 'openssl_ts ts -verify -data %s -CAfile %s -in %s' % \
                          (newfilesPathName, chainfile, tsrfile)
                    os.system(cmd)
            else:
                print 'Fehler aufgetreten:'
                print lines
        else:
            print 'Fehler aufgetreten:'
            print lines
    else:
        pass # no previous backup

    # remove obsolete directories
    if len(mydirs) > numberdirs:
       top = os.path.join(backupdir, mydirs[0])
       for root, dirs, files in os.walk(top, topdown=False):
           for name in files:
               os.remove(os.path.join(root, name))
           for name in dirs:
               os.rmdir(os.path.join(root, name)) 
       os.rmdir(top)
       print 'backup dir "%s" removed' % top
#    os.system('kio_media_mounthelper -u /media/disk') # umount disk KDE3
    os.system('/usr/bin/pumount /media/disk') # umount disk,  requires pmount
    os.system('/usr/bin/kdialog --msgbox "Datensicherung erfolgreich abgeschlossen."')
except IndexError:
    os.system('/usr/bin/kdialog --error "Datensicherung fehlgeschlagen."')
